import { useQuery, useQueryClient } from "@tanstack/react-query"

import { getUser } from "../api/get-user"
import { IUser } from "../types"

export const useUser = (username: string | undefined) => {
    const queryClient = useQueryClient()
    return useQuery<IUser>(
        ["users", username],
        async () => {
            return getUser(username)
        },
        {
            refetchOnWindowFocus: false,
            onSuccess: (data) => {
                queryClient.setQueryData(["users", username], data)
            },
        },
    )
}